"use strict";
var hmr_store_1 = require('./hmr-store');
function HmrState(namespaceOrConfig, config) {
    function decoratorFactory(target, decoratedPropertyName, descriptor) {
        if (!hmr_store_1.HmrStore.dev) {
            return descriptor;
        }
        var key = namespaceOrConfig || target.constructor.name + '#' + decoratedPropertyName;
        hmr_store_1.HmrStore.select(key, function () { return hmr_store_1.HmrStore.get(key); });
        Object.defineProperty(target, decoratedPropertyName, {
            get: function () { return hmr_store_1.HmrStore.get(key); },
            set: function (newValue) {
                var currentValue = hmr_store_1.HmrStore.get(key);
                if (!currentValue) {
                    hmr_store_1.HmrStore._initialValues[key] = newValue;
                }
                else {
                    newValue = Object.assign(newValue, currentValue);
                }
                return hmr_store_1.HmrStore.set(key, newValue);
            },
            enumerable: true,
            configurable: true
        });
        return descriptor;
    }
    return decoratorFactory;
}
exports.HmrState = HmrState;
//# sourceMappingURL=hmr-decorator.js.map